//! Bot data models

use serde::{Deserialize, Serialize};

pub const COLLECTIONS_NAMES: [&str; 1] = ["guilds"];

pub trait YorokobotCollection: for<'de> Deserialize<'de> + Serialize + Unpin + Send + Sync {
    fn get_collection_name() -> String;
}

/// Tags
#[derive(Debug, Serialize, Deserialize, Clone)]
pub struct Tag {
    pub name: String,
    pub is_nsfw: bool,
    pub subscribers: Vec<String>,
}

#[derive(Debug, Serialize, Deserialize, Clone)]
pub struct Guild {
    #[serde(rename = "_id")]
    pub id: String,
    pub ban_list: Vec<String>,
    pub tags: Vec<Tag>,
}

impl YorokobotCollection for Guild {
    fn get_collection_name() -> String {
        COLLECTIONS_NAMES[0].to_string()
    }
}
